=== modified file 'Makefile'
--- Makefile	2008-09-17 00:34:09 +0000
+++ Makefile	2008-09-19 20:54:58 +0000
@@ -151,7 +151,7 @@
 		$(DESTDIR)/etc/init.d/mandos
 	install --mode=u=rw,go=r default-mandos \
 		$(DESTDIR)/etc/default/mandos
-	update-rc.d mandos defaults
+	if [ -z $(DESTDIR) ]; then update-rc.d mandos defaults; fi
 	gzip --best --to-stdout mandos.8 \
 		> $(MANDIR)/man8/mandos.8.gz
 	gzip --best --to-stdout mandos.conf.5 \
@@ -166,8 +166,6 @@
 	if [ "$(CONFDIR)" != "$(PREFIX)/lib/mandos" ]; then \
 		install --mode=u=rwx \
 			--directory "$(CONFDIR)/plugins.d" && \
-		install --mode=u=rw,go=r etc-plugins.d-README \
-			$(CONFDIR)/plugins.d/README ; \
 	fi
 	install --mode=u=rwx,go=rx \
 		--target-directory=$(PREFIX)/lib/mandos plugin-runner

=== modified file 'TODO'
--- TODO	2008-09-19 00:00:51 +0000
+++ TODO	2008-09-19 23:31:34 +0000
@@ -1,8 +1,6 @@
 -*- org -*-
 
-* plugin-runner
-** TODO Man page  for plugin-runner.conf.5
-   link to plugin-runner.8
+* DONE plugin-runner
 
 * mandos-client
 ** TODO [#B] Temporarily lower kernel log level
@@ -41,18 +39,11 @@
 
 * Installer
 ** Client-side
-*** TODO Update initrd.img after installation
-    This seems to use some kind of "trigger" system
-    [[file:/usr/share/doc/dpkg/triggers.txt.gz]]
-    dpkg-trigger(1), deb-triggers(5)
 *** mandos-keygen
-**** TODO [#A] Ask for password twice for confirmation
-**** TODO "--passfile" option
+**** TODO "--secfile" option
      Using the "secfile" option instead of "secret"
 **** TODO [#B] "--test" option
      For testing decryption before rebooting.
-** Server-side
-*** TODO [#A] Create mandos user and group for server
 
 
 * [#A] Package
@@ -63,9 +54,6 @@
 ** TODO /etc/bash_completion.d/mandos
    From XML sources directly?
 ** TODO unperish
-** DONE bzr-builddeb
-** TODO mandos user/group creation
-** TODO Key creation in postinst
 
 * TODO Web site
 ** DONE http://www.fukt.bsnet.se/mandos

=== modified file 'debian/control'
--- debian/control	2008-09-17 00:34:09 +0000
+++ debian/control	2008-09-19 20:54:58 +0000
@@ -2,17 +2,16 @@
 Section: admin
 Priority: extra
 Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Build-Depends: debhelper (>= 7), docbook-xsl, docbook (<5.0),
-	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc
+Build-Depends: debhelper (>= 7), docbook-xsl, libavahi-core-dev,
+	libgpgme11-dev, libgnutls-dev, xsltproc
 Standards-Version: 3.8.0
 Vcs-Bzr: ftp://anonymous@ftp.fukt.bsnet.se/pub/mandos/latest
 Homepage: http://www.fukt.bsnet.se/mandos
 
 Package: mandos
 Architecture: all
-Depends: ${shlibs:Depends}, ${misc:Depends}, python (>=2.5),
-	python-gnutls, python-dbus, python-avahi, avahi-daemon,
-	gnupg (< 2)
+Depends: python (>=2.5), python-gnutls, python-dbus, python-avahi,
+	avahi-daemon, gnupg (< 2), adduser
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
@@ -31,7 +30,7 @@
 
 Package: mandos-client
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, adduser, cryptsetup
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2008-09-19 00:00:51 +0000
+++ debian/mandos-client.README.Debian	2008-09-19 20:54:58 +0000
@@ -8,8 +8,16 @@
 change the line there.  If this file is changed, it will be necessary
 to update the initrd image by doing "update-initramfs -k all -u".
 
+Any plugins found in /etc/mandos/plugins.d will override and add to
+the normal Mandos plugins.  When adding or changing plugins, do not
+forget to update the initital RAM disk image:
+
+# update-initramfs -k all -u
+
 It is NOT necessary to edit /etc/crypttab to specify
 /usr/lib/mandos/plugin-runner as a keyscript for the root file system;
 if no keyscript is given for the root file system, the Mandos client
 will be the new default way for getting a password for the root file
 system when booting.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Fri, 19 Sep 2008 22:50:16 +0200

=== added file 'debian/mandos-client.docs'
--- debian/mandos-client.docs	1970-01-01 00:00:00 +0000
+++ debian/mandos-client.docs	2008-09-19 13:50:22 +0000
@@ -0,0 +1,2 @@
+README
+TODO

=== added file 'debian/mandos-client.links'
--- debian/mandos-client.links	1970-01-01 00:00:00 +0000
+++ debian/mandos-client.links	2008-09-19 13:50:22 +0000
@@ -0,0 +1,1 @@
+usr/share/man/man8/plugin-runner.8mandos.gz usr/share/man/man5/plugin-runner.conf.5mandos.gz

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2008-09-17 00:34:09 +0000
+++ debian/mandos-client.postinst	2008-09-19 17:30:43 +0000
@@ -17,19 +17,40 @@
 
 . /usr/share/debconf/confmodule
 
-# Update the initramfs
+# Update the initial RAM file system image
 update_initramfs()
 {
-	if which update-initramfs >/dev/null 2>&1; then
-		update-initramfs -u
-	fi
+    if [ -x /usr/sbin/update-initramfs ]; then
+	update-initramfs -u -k all
+    fi
+}
+
+# Add user and group
+add_mandos_user(){
+    if ! getent passwd mandos >/dev/null; then
+	adduser --disabled-password  --quiet --system \
+	    --home /var/run/mandos --no-create-home \
+	    --gecos "Mandos password system" --group mandos
+    fi
+}
+
+# Create client key pair
+create_key(){
+    if [ -r /etc/keys/mandos/pubkey.txt \
+	-a -r /etc/keys/mandos/seckey.txt ]; then
+	return 0
+    fi
+    if [ -x /usr/sbin/mandos-keygen ]; then
+	mandos-keygen
+    fi
 }
 
 case "$1" in
     configure)
+	add_mandos_user
+	create_key
 	update_initramfs
 	;;
-
     abort-upgrade|abort-deconfigure|abort-remove)
 	;;
 

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2008-09-19 00:00:51 +0000
+++ debian/mandos-client.postrm	2008-09-19 20:54:58 +0000
@@ -27,26 +27,24 @@
 #       <new-postrm> abort-upgrade <old-version>
 
 
-# Update the initramfs
+# Update the initial RAM file system image
 update_initramfs()
 {
-	if type update-initramfs >/dev/null 2>&1 ; then
-		update-initramfs -u -k all
-	fi
+    if [ -x /usr/sbin/update-initramfs ]; then
+	update-initramfs -u -k all
+    fi
 }
 
-
 case "$1" in
     remove)
 	update_initramfs
 	;;
 
     purge)
-	shred --remove /etc/keys/mandos/seckey.txt || :
+	shred --remove /etc/keys/mandos/seckey.txt 2>/dev/null || :
 	rm --force /etc/mandos/plugin-runner.conf \
 	    /etc/keys/mandos/pubkey.txt \
-	    /etc/keys/mandos/seckey.txt
-	rmdir /etc/keys/mandos /etc/mandos/plugins.d /etc/mandos || :
+	    /etc/keys/mandos/seckey.txt 2>/dev/null
 	;;
     upgrade|failed-upgrade|disappear|abort-install|abort-upgrade)
 	;;

=== added file 'debian/mandos.docs'
--- debian/mandos.docs	1970-01-01 00:00:00 +0000
+++ debian/mandos.docs	2008-09-19 13:50:22 +0000
@@ -0,0 +1,2 @@
+README
+TODO

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2008-09-19 00:54:24 +0000
+++ debian/mandos.postinst	2008-09-19 17:30:43 +0000
@@ -22,7 +22,7 @@
 	if ! getent passwd mandos >/dev/null; then
 	    adduser --disabled-password  --quiet --system \
 		--home /var/run/mandos --no-create-home \
-		--gecos "Mandos password daemon" --group mandos
+		--gecos "Mandos password system" --group mandos
 	fi
 	;;
 

=== removed file 'debian/mandos.postrm'
--- debian/mandos.postrm	2008-09-19 00:54:24 +0000
+++ debian/mandos.postrm	1970-01-01 00:00:00 +0000
@@ -1,11 +0,0 @@
-#!/bin/sh
-
-set -e
-
-#DEBHELPER#
-
-if [ "$1" = "purge" ] ; then
-        deluser --quiet --system mandos > /dev/null || true
-        delgroup --quiet --system mandos > /dev/null || true
-fi
-

=== modified file 'debian/rules'
--- debian/rules	2008-09-17 00:34:09 +0000
+++ debian/rules	2008-09-19 13:50:22 +0000
@@ -10,7 +10,7 @@
 # build-arch and build-indep targets  by Bill Allombert 2001
 
 # Uncomment this to turn on verbose mode.
-export DH_VERBOSE=1
+#export DH_VERBOSE=1
 
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
@@ -18,21 +18,17 @@
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
-# Add here commands to configure the package.
 	touch configure-stamp
 
-#Architecture
 build: build-arch build-indep
 
 build-arch: build-arch-stamp
 build-arch-stamp: configure-stamp
-# Add here commands to compile the arch part of the package.
 	dh_auto_build -- all doc
 	touch $@
 
 build-indep: build-indep-stamp
 build-indep-stamp: configure-stamp
-# Add here commands to compile the indep part of the package.
 	dh_auto_build -- doc
 	touch $@
 
@@ -40,7 +36,6 @@
 	dh_testdir
 	dh_testroot
 	rm -f build-arch-stamp build-indep-stamp configure-stamp
-# Add here commands to clean up after the build process.
 	dh_auto_clean
 	dh_clean
 
@@ -50,8 +45,6 @@
 	dh_testroot
 	dh_prep
 	dh_installdirs --indep
-# Add here commands to install the indep part of the package into
-# debian/<package>-doc.
 	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
 	dh_lintian
 	dh_installinit --onlyscripts --no-start
@@ -62,46 +55,28 @@
 	dh_testroot
 	dh_prep
 	dh_installdirs --same-arch
-
-# Add here commands to install the arch part of the package into
-# debian/tmp.
 	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client install-client-nokey
 	dh_lintian
 	dh_install --same-arch
 
-# Must not depend on anything. This is to be called by
-# binary-arch/binary-indep
-# in another 'make' thread.
 binary-common:
 	dh_testdir
 	dh_testroot
 	dh_installchangelogs
 	dh_installdocs
-#	dh_installexamples
-#	dh_installmenu
 #	dh_installdebconf
-#	dh_installlogrotate
-#	dh_installemacsen
-#	dh_installpam
-#	dh_installmime
-#	dh_pycentral
-#	dh_installinit
-#	dh_installcron
-#	dh_installinfo
-#	dh_installman
 	dh_link
 	dh_strip
 	dh_compress
 	dh_fixperms --exclude etc/keys/mandos \
 		--exclude etc/mandos/clients.conf \
 		--exclude usr/lib/mandos/plugins.d
-#	dh_perl
-	dh_makeshlibs
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol
 	dh_md5sums
 	dh_builddeb
+
 # Build architecture independant packages using the common target.
 binary-indep: build-indep install-indep
 	$(MAKE) -f debian/rules DH_OPTIONS=--indep binary-common

=== removed file 'etc-plugins.d-README'
--- etc-plugins.d-README	2008-09-06 16:11:50 +0000
+++ etc-plugins.d-README	1970-01-01 00:00:00 +0000
@@ -1,5 +0,0 @@
-Any plugins found here in /etc/mandos/plugins.d will override and add
-to the normal Mandos plugins.  When adding or changing plugins, do not
-forget to update the initital RAM disk image:
-
-# update-initramfs -k all -u

=== modified file 'mandos-keygen'
--- mandos-keygen	2008-09-08 12:03:16 +0000
+++ mandos-keygen	2008-09-19 23:31:34 +0000
@@ -27,7 +27,7 @@
 KEYLENGTH=2048
 SUBKEYTYPE=ELG-E
 SUBKEYLENGTH=2048
-KEYNAME="`hostname --fqdn`"
+KEYNAME="`hostname --fqdn 2>/dev/null || hostname`"
 KEYEMAIL=""
 KEYCOMMENT="Mandos client key"
 KEYEXPIRE=0
@@ -40,8 +40,8 @@
 fi
 
 # Parse options
-TEMP=`getopt --options vhd:t:l:n:e:c:x:f \
-    --longoptions version,help,password,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force \
+TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:f \
+    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force \
     --name "$0" -- "$@"`
 
 help(){
@@ -53,6 +53,7 @@
        $basename [ OPTIONS ]
    Encrypted password creation:
        $basename { -p | --password } [ --name NAME ] [ --dir DIR]
+       $basename { -F | --passfile } FILE [ --name NAME ] [ --dir DIR]
 
 Key creation options:
   -v, --version         Show program's version number and exit
@@ -74,10 +75,14 @@
   -x TIME, --expire TIME
                         Key expire time.  Default is no expiration.
                         See gpg(1) for syntax.
-  -f, --force           Force overwriting old keys.
+  -f, --force           Force overwriting old key files.
 
 Password creation options:
-  -p, --password        Create an encrypted password using the keys in
+  -p, --password        Create an encrypted password using the key in
+                        the key directory.  All options other than
+                        --dir and --name are ignored.
+  -F FILE, --passfile FILE
+                        Encrypt a password from FILE using the key in
                         the key directory.  All options other than
                         --dir and --name are ignored.
 EOF
@@ -87,6 +92,7 @@
 while :; do
     case "$1" in
 	-p|--password) mode=password; shift;;
+	-F|--passfile) mode=password; PASSFILE="$2"; shift 2;;
 	-d|--dir) KEYDIR="$2"; shift 2;;
 	-t|--type) KEYTYPE="$2"; shift 2;;
 	-s|--subtype) SUBKEYTYPE="$2"; shift 2;;
@@ -235,7 +241,7 @@
 	FILECOMMENT="$FILECOMMENT <$KEYEMAIL>"
     fi
     
-    # Export keys from key rings to key files
+    # Export key from key rings to key files
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --armor --export-options export-minimal \
 	--comment "$FILECOMMENT" --output "$SECKEYFILE" \
@@ -246,7 +252,7 @@
 fi
 
 if [ "$mode" = password ]; then
-    # Import keys into temporary key rings
+    # Import key into temporary key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always --armor \
 	--import "$SECKEYFILE"
@@ -265,22 +271,37 @@
     
     FILECOMMENT="Encrypted password for a Mandos client"
     
-    stty -echo
-    echo -n "Enter passphrase: " >&2
-    head --lines=1 | tr --delete '\n' \
-	| gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
+    if [ -n "$PASSFILE" ]; then
+	cat "$PASSFILE"
+    else
+	stty -echo
+	echo -n "Enter passphrase: " >&2
+	first="$(head --lines=1 | tr --delete '\n')"
+	echo -n -e "\nRepeat passphrase: " >&2
+	second="$(head --lines=1 | tr --delete '\n')"
+	echo >&2
+	stty echo
+	if [ "$first" != "$second" ]; then
+	    echo -e "Passphrase mismatch" >&2
+	    false
+	else
+	    echo -n "$first"
+	fi
+    fi | gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always --armor --encrypt \
 	--recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
 	> "$SECFILE"
-    echo >&2
-    stty echo
+    status="${PIPESTATUS[0]}"
+    if [ "$status" -ne 0 ]; then
+	exit "$status"
+    fi
     
     cat <<-EOF
 	[$KEYNAME]
 	host = $KEYNAME
 	fingerprint = $FINGERPRINT
 	secret =
-EOF
+	EOF
     sed --quiet --expression='
 	/^-----BEGIN PGP MESSAGE-----$/,/^-----END PGP MESSAGE-----$/{
 	    /^$/,${

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2008-09-12 19:12:40 +0000
+++ mandos-keygen.xml	2008-09-19 23:31:34 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2008-09-12">
+<!ENTITY TIMESTAMP "2008-09-20">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -122,6 +122,10 @@
       <group choice="req">
 	<arg choice="plain"><option>--password</option></arg>
 	<arg choice="plain"><option>-p</option></arg>
+	<arg choice="plain"><option>--passfile
+	<replaceable>FILE</replaceable></option></arg>
+	<arg choice="plain"><option>-F</option>
+	<replaceable>FILE</replaceable></arg>
       </group>
       <sbr/>
       <group>
@@ -167,8 +171,9 @@
     </para>
     <para>
       This program can also be used with the
-      <option>--password</option> option to generate a ready-made
-      section for <filename>clients.conf</filename> (see
+      <option>--password</option> or <option>--passfile</option>
+      options to generate a ready-made section for
+      <filename>clients.conf</filename> (see
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>).
     </para>
@@ -326,6 +331,18 @@
 	  </para>
 	</listitem>
       </varlistentry>
+      <varlistentry>
+	<term><option>--passfile
+	<replaceable>FILE</replaceable></option></term>
+	<term><option>-F
+	<replaceable>FILE</replaceable></option></term>
+	<listitem>
+	  <para>
+	    The same as <option>--password</option>, but read from
+	    <replaceable>FILE</replaceable>, not the terminal.
+	  </para>
+	</listitem>
+      </varlistentry>
     </variablelist>
   </refsect1>
   

